// MIDI to Arduino File Converter V1.0
// Written by agp.cooper@gmail.com
// Copyright 2017, but free for personal use.
// Suitable for: ATmega48A/PA/88A/PA/168A/PA/328/P

// In case you did not know:
//   Paste "SimpleMidiPlayer.ino" into an empty Arduino sketch.
//   Hook up 100R speakers to pins A0-5 (and return to ground).
//   If possible a "Channel" number that is more than 0 to 5 is remapped.
//   If a "Channel" is not required then remap it to 16 or higher.
// Enjoy.

#include <avr/pgmspace.h>
const byte PROGMEM MidiData[] = {
    9, 1, 46,
  240, 1,  0,
    0, 2, 50,
    1, 1, 53,
  248, 1,  0,
    0, 2,  0,
    1, 1, 41,
  247, 1,  0,
    0, 2, 50,
    1, 1, 53,
  256, 1,  0,
    4, 1,  0,
    0, 2,  0,
    1, 1, 46,
  247, 1,  0,
    0, 2, 50,
    1, 1, 53,
  248, 1,  0,
    0, 2,  0,
    1, 1, 41,
  256, 1,  0,
    4, 1,  0,
    0, 2, 50,
    1, 1, 53,
  247, 1,  0,
    0, 2,  0,
    1, 1, 46,
  248, 1,  0,
    0, 2, 50,
    1, 1, 53,
  256, 1,  0,
    4, 1,  0,
    0,16, 97,
    1,16,  0,
    0, 2,  0,
    1, 1, 41,
  247, 1,  0,
    0,16,103,
    1,16,  0,
    0, 2, 50,
    1, 1, 53,
    0,16,112,
    1,16,  0,
    0,16, 46,
    1,16,  0,
  248, 1,  0,
    0, 2,  0,
    0,16, 99,
    1,16,  0,
    1, 1, 46,
  256, 1,  0,
    4, 1,  0,
    4, 0, 67,
    0,16,111,
    1,16,  0,
    0, 1, 53,
    0, 2, 50,
  250, 0,  0,
    0, 1,  0,
    0,16,111,
    1,16,  0,
    0,16,112,
    1,16,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 41,
   56, 0,  0,
    0,16,101,
    1,16,  0,
    1, 0, 68,
   66, 0,  0,
    0,16,114,
    1,16,  0,
    0,16, 64,
    1,16,  0,
    6, 0, 69,
   56, 0,  0,
    1, 0, 70,
   56, 0,  0,
    0,16,103,
    1,16,  0,
    6, 0, 70,
    0, 1,  0,
    0,16,109,
    1,16,  0,
    0, 2, 50,
    1, 1, 53,
   66, 0,  0,
  191, 0, 70,
    0,16, 97,
    1,16,  0,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  248, 0,  0,
    0, 1,  0,
    0, 2, 50,
    0,16,105,
    1,16,  0,
    1, 0, 70,
    0, 1, 53,
    0,16,108,
    1,16,  0,
    0,16, 46,
    1,16,  0,
  250, 0,  0,
    0, 1,  0,
    0,16, 99,
    1,16,  0,
    0,16,111,
    1,16,  0,
    0, 2,  0,
    1, 0, 67,
    0,16,109,
    1,16,  0,
    0, 1, 41,
  129, 0,  0,
    1, 0, 65,
  128, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 62,
    0, 1, 53,
  114, 0,  0,
    4, 0, 62,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 46,
  130, 0,  0,
    1, 0, 65,
  112, 0,  0,
    6, 0, 67,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  129, 0,  0,
    1, 0, 65,
  128, 0,  0,
    0, 1,  0,
    0, 2,  0,
    5, 0, 65,
    0, 1, 41,
  114, 0,  0,
    1, 0, 62,
  129, 0,  0,
    6, 0, 60,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  129, 0,  0,
    1, 0, 58,
  113, 0,  0,
    5, 0, 58,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 58,
    0, 1, 53,
  113, 0,  0,
    5, 0, 62,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 62,
    0, 1, 41,
  129, 0,  0,
    1, 0, 65,
  113, 0,  0,
    5, 0, 67,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  128, 0,  0,
    1, 0, 65,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  250, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  248, 1,  0,
    0, 2,  0,
    1, 1, 41,
  128, 0, 65,
  130, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 67,
    0, 1, 53,
  113, 0,  0,
    5, 0, 69,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  248, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    6, 0, 67,
    0, 1, 41,
  113, 0,  0,
    6, 0, 65,
  130, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 62,
    0, 1, 53,
  128, 0,  0,
    1, 0, 62,
  114, 0,  0,
    4, 0, 65,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  129, 0,  0,
    1, 0, 65,
  130, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 67,
    0, 1, 53,
  112, 0,  0,
    6, 0, 65,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 41,
  128, 0,  0,
    1, 0, 62,
  114, 0,  0,
    4, 0, 60,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  129, 0,  0,
    1, 0, 58,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 45,
  248, 0,  0,
    0, 1,  0,
    0, 2, 48,
    1, 0, 65,
    0, 1, 53,
  128, 0,  0,
    1, 0, 65,
  113, 0,  0,
    5, 0, 69,
    0, 1,  0,
    0, 2,  0,
    1, 1, 41,
  129, 0,  0,
    1, 0, 72,
  130, 0,  0,
    0, 1,  0,
    5, 0, 69,
    0, 1, 53,
    0, 2, 48,
  114, 0,  0,
    1, 0, 67,
  128, 0,  0,
    5, 0, 65,
    0, 1,  0,
    0, 2,  0,
    1, 1, 45,
  248, 0,  0,
    0, 1,  0,
    0, 2, 48,
    1, 1, 53,
  256, 1,  0,
    4, 1,  0,
    0, 2,  0,
    1, 1, 41,
  118, 0, 65,
  129, 0,  0,
    0, 1,  0,
    0, 2, 48,
    1, 0, 67,
    0, 1, 53,
  129, 0,  0,
    1, 0, 69,
  113, 0,  0,
    5, 0, 70,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  256, 0,  0,
    3, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 41,
  248, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  256, 0,  0,
    3, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  248, 0,  0,
    0, 1,  0,
    1, 0, 70,
    0, 1, 50,
  248, 0,  0,
    0, 1,  0,
    1, 0, 67,
    0, 1, 53,
  130, 0,  0,
    5, 0, 65,
  123, 1,  0,
    5, 0,  0,
    0, 1, 56,
    1, 0, 62,
  113, 0,  0,
    5, 0, 58,
  130, 0,  0,
    0, 1,  0,
    1, 0, 63,
    0, 1, 51,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 63,
    0, 1, 58,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 46,
  248, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 63,
    0, 1, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 51,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    1, 0, 70,
    0, 1, 55,
  113, 0,  0,
    5, 0, 72,
  131, 0,  0,
    0, 1,  0,
    1, 0, 73,
    0, 1, 58,
  129, 0,  0,
    1, 0, 70,
  118, 1,  0,
    1, 1, 61,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    5, 0, 74,
    0, 1, 46,
  114, 0,  0,
    1, 0, 73,
  130, 0,  0,
    5, 0, 74,
    0, 1,  0,
    0, 2, 53,
    1, 1, 58,
  128, 0,  0,
    1, 0, 73,
  114, 0,  0,
    5, 0, 74,
    0, 1,  0,
    0, 2,  0,
    1, 1, 41,
  128, 0,  0,
    1, 0, 77,
  130, 1,  0,
    0, 2, 53,
    1, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 74,
    0, 1, 46,
  128, 0,  0,
    1, 0, 77,
  114, 0,  0,
    4, 0, 74,
    0, 1,  0,
    0, 2, 53,
    1, 1, 58,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 41,
  248, 0,  0,
    0, 1,  0,
    0, 2, 53,
    1, 0, 65,
    0, 1, 58,
  247, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 79,
    0, 1, 46,
  129, 0,  0,
    1, 0, 74,
  130, 1,  0,
    0, 2, 53,
    1, 1, 58,
  118, 0,  0,
    1, 0, 70,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 57,
    0, 2, 53,
  247, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 62,
    0, 2, 58,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2,  0,
  254, 0, 67,
  250, 0,  0,
    1, 0, 67,
   66, 0,  0,
    1, 0, 68,
   56, 0,  0,
    6, 0, 69,
   56, 0,  0,
    1, 0, 70,
   67, 0,  0,
    5, 0, 70,
   57, 0,  0,
  191, 0, 70,
    0, 1, 46,
  250, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 41,
  113, 0,  0,
    5, 0, 65,
  129, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 62,
    0, 1, 53,
  129, 0,  0,
    1, 0, 62,
  113, 0,  0,
    5, 0, 65,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  130, 0,  0,
    1, 0, 65,
  129, 0,  0,
    0, 1,  0,
    4, 0, 67,
    0, 1, 53,
    0, 2, 50,
  115, 0,  0,
    1, 0, 65,
  128, 0,  0,
    5, 0, 65,
    0, 1,  0,
    0, 2,  0,
    1, 1, 41,
  130, 0,  0,
    1, 0, 62,
  112, 0,  0,
    6, 0, 60,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  129, 0,  0,
    1, 0, 58,
  128, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 58,
    0, 1, 46,
  248, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 58,
    0, 1, 53,
  130, 0,  0,
    1, 0, 62,
  112, 0,  0,
    6, 0, 62,
    0, 1,  0,
    0, 2,  0,
    1, 1, 41,
  129, 0,  0,
    1, 0, 65,
  128, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 67,
    0, 1, 53,
  114, 0,  0,
    4, 0, 65,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  250, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  256, 1,  0,
    2, 1,  0,
    0, 2,  0,
    1, 1, 41,
  118, 0, 65,
  130, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 67,
    0, 1, 53,
  130, 0,  0,
    5, 0, 69,
  114, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    5, 0, 70,
    0, 1, 53,
    0, 2, 50,
  251, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 41,
  129, 0,  0,
    1, 0, 65,
  113, 0,  0,
    5, 0, 62,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  128, 0,  0,
    1, 0, 62,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 46,
  113, 0,  0,
    5, 0, 65,
  131, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 67,
    0, 1, 53,
  129, 0,  0,
    1, 0, 65,
  113, 0,  0,
    5, 0, 65,
    0, 1,  0,
    0, 2,  0,
    1, 1, 41,
  128, 0,  0,
    1, 0, 62,
  129, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 60,
    0, 1, 53,
  113, 0,  0,
    5, 0, 58,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 45,
  248, 0,  0,
    0, 1,  0,
    0, 2, 48,
    1, 0, 65,
    0, 1, 53,
  128, 0,  0,
    1, 0, 65,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    6, 0, 69,
    0, 1, 41,
  113, 0,  0,
    1, 0, 72,
  130, 0,  0,
    5, 0, 69,
    0, 1,  0,
    0, 2, 48,
    1, 1, 53,
  128, 0,  0,
    1, 0, 67,
  114, 0,  0,
    4, 0, 65,
    0, 1,  0,
    0, 2,  0,
    1, 1, 45,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2, 48,
    1, 1, 53,
  248, 1,  0,
    0, 2,  0,
    1, 1, 41,
  128, 0, 65,
  114, 0,  0,
    5, 0, 67,
    0, 1,  0,
    0, 2, 48,
    1, 1, 53,
  129, 0,  0,
    1, 0, 69,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  247, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 41,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  247, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  248, 0,  0,
    0, 1,  0,
    1, 0, 70,
    0, 1, 50,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    4, 0, 67,
    0, 1, 53,
  115, 0,  0,
    5, 0, 65,
  129, 0,  0,
    0, 1,  0,
    1, 0, 62,
    0, 1, 56,
  129, 0,  0,
    1, 0, 58,
  113, 0,  0,
    5, 0, 63,
    0, 1,  0,
    1, 1, 51,
  256, 0,  0,
    3, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 63,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 46,
  248, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 63,
    0, 1, 58,
  256, 0,  0,
    3, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 51,
  248, 0,  0,
    0, 1,  0,
    1, 0, 70,
    0, 1, 55,
  130, 0,  0,
    1, 0, 72,
  112, 0,  0,
    6, 0, 73,
    0, 1,  0,
    1, 1, 58,
  129, 0,  0,
    1, 0, 70,
  128, 1,  0,
    5, 1, 61,
  244, 0,  0,
    5, 0, 74,
    0, 1,  0,
    1, 1, 46,
  130, 0,  0,
    1, 0, 73,
  113, 0,  0,
    5, 0, 74,
    0, 1,  0,
    0, 2, 53,
    1, 1, 58,
  128, 0,  0,
    1, 0, 73,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 74,
    0, 1, 41,
  113, 0,  0,
    5, 0, 77,
  131, 1,  0,
    0, 2, 53,
    1, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 74,
    0, 1, 46,
  128, 0,  0,
    1, 0, 77,
  129, 0,  0,
    0, 1,  0,
    0, 2, 53,
    1, 0, 74,
    0, 1, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 41,
  248, 0,  0,
    0, 1,  0,
    0, 2, 53,
    1, 0, 65,
    0, 1, 58,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 79,
    0, 1, 46,
  113, 0,  0,
    5, 0, 74,
  131, 1,  0,
    0, 2, 53,
    1, 1, 58,
  129, 0,  0,
    4, 0, 70,
  115, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 57,
    0, 2, 53,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    6, 0, 70,
    0, 1, 62,
    0, 2, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
  256, 1, 46,
  256, 1, 46,
  256, 1, 46,
  241, 1, 46,
  256, 1,  0,
    5, 1,  0,
    0, 2, 50,
    1, 1, 53,
  248, 1,  0,
    0, 2,  0,
    1, 1, 41,
  247, 1,  0,
    0, 2, 50,
    1, 1, 53,
  256, 1,  0,
    4, 1,  0,
    0, 2,  0,
    5, 1, 46,
  248, 1,  0,
    0, 2, 50,
    1, 1, 53,
  248, 1,  0,
    0, 2,  0,
    1, 1, 41,
  256, 1,  0,
    4, 1,  0,
    0, 2, 50,
    1, 1, 53,
  247, 1,  0,
    0, 2,  0,
    1, 1, 46,
  248, 1,  0,
    0, 2, 50,
    1, 1, 53,
  256, 1,  0,
    4, 1,  0,
    0, 2,  0,
    1, 1, 41,
  247, 1,  0,
    0, 2, 50,
    1, 1, 53,
  248, 1,  0,
    0, 2,  0,
    1, 1, 46,
  256, 1,  0,
    4, 1,  0,
    1, 1, 50,
  247, 0, 74,
    0, 1,  0,
    1, 1, 53,
  248, 1,  0,
    1, 1, 57,
  256, 0,  0,
    3, 0,  0,
    0, 1,  0,
    5, 0, 75,
    0, 1, 51,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 74,
    0, 1, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 46,
  129, 0,  0,
    1, 0, 74,
  128, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 72,
    0, 1, 58,
  114, 0,  0,
    4, 0, 74,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 51,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 70,
    0, 1, 58,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 69,
    0, 1, 46,
  248, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 70,
    0, 1, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 51,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    5, 0, 70,
    0, 1, 58,
    0, 2, 55,
  251, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 69,
    0, 1, 46,
  129, 0,  0,
    1, 0, 70,
  113, 0,  0,
    5, 0, 69,
    0, 1,  0,
    0, 2, 55,
    1, 1, 58,
  128, 0,  0,
    1, 0, 70,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 68,
    0, 1, 51,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 67,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 66,
    0, 1, 46,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 67,
    0, 1, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 51,
  248, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 1, 58,
  128, 0, 65,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 46,
  112, 0,  0,
    5, 0, 70,
  131, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 70,
    0, 1, 58,
  128, 0,  0,
    5, 0, 67,
  114, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 75,
    0, 1, 51,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    5, 0, 75,
    0, 1, 58,
    0, 2, 55,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 46,
  129, 0,  0,
    1, 0, 70,
  113, 0,  0,
    5, 0, 67,
    0, 1,  0,
    0, 2, 55,
    1, 1, 58,
  129, 0,  0,
    1, 0, 63,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 50,
  247, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 70,
    0, 1, 58,
  129, 0,  0,
    1, 0, 72,
  113, 0,  0,
    5, 0, 74,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  130, 0,  0,
    1, 0, 77,
  129, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 74,
    0, 1, 58,
  247, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 50,
  248, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 1, 58,
  256, 1,  0,
    4, 1,  0,
    0, 2,  0,
    4, 1, 46,
  250, 1,  0,
    0, 2, 56,
    1, 1, 58,
  248, 0, 63,
    0, 1,  0,
    0, 2,  0,
    1, 1, 51,
  256, 0,  0,
    3, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 75,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 46,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 75,
    0, 1, 58,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 51,
  248, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 75,
    0, 1, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 39,
  129, 0,  0,
    1, 0, 70,
  128, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 67,
    0, 1, 61,
  114, 0,  0,
    4, 0, 65,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 44,
  250, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 75,
    0, 1, 60,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    5, 0, 63,
    0, 1, 39,
  251, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 75,
    0, 1, 60,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 44,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 75,
    0, 1, 60,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 60,
    0, 2, 56,
  129, 0,  0,
    1, 0, 70,
  113, 0,  0,
    5, 0, 67,
    0, 1,  0,
    0, 2,  0,
  129, 0,  0,
    1, 0, 65,
  129, 0,  0,
    0, 1, 51,
    1, 0, 63,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 63,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 46,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    6, 0, 70,
    0, 1, 58,
    0, 2, 55,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 50,
  247, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 67,
    0, 1, 58,
  129, 0,  0,
    1, 0, 68,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 68,
    0, 1, 46,
  112, 0,  0,
    6, 0, 72,
  130, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 70,
    0, 1, 58,
  247, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 75,
    0, 1, 51,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 75,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 46,
  128, 0,  0,
    1, 0, 70,
  113, 0,  0,
    5, 0, 67,
    0, 1,  0,
    0, 2, 55,
    1, 1, 58,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 51,
  248, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 1, 58,
  247, 1,  0,
    0, 2,  0,
    1, 1, 46,
  135, 0, 63,
  125, 1,  0,
    5, 0,  0,
    0, 1, 58,
    0, 2, 55,
    1, 0, 75,
  113, 0,  0,
    5, 0, 75,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 51,
  248, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 70,
    0, 1, 58,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 46,
  247, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 63,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 51,
  130, 0,  0,
    1, 0, 67,
  128, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 65,
    0, 1, 58,
  114, 0,  0,
    5, 0, 63,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 60,
    0, 1, 46,
  130, 0,  0,
    1, 0, 58,
  117, 1,  0,
    0, 2, 55,
    1, 1, 58,
  130, 0,  0,
  129, 1,  0,
    0, 2,  0,
    5, 0, 63,
    0, 1, 51,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 65,
    0, 1, 58,
  130, 0,  0,
    1, 0, 67,
  112, 0,  0,
    6, 0, 67,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  129, 0,  0,
    1, 0, 68,
  128, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 70,
    0, 1, 58,
  113, 0,  0,
    5, 0, 67,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 51,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 72,
    0, 1, 58,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  248, 1,  0,
    0, 2, 55,
    1, 1, 58,
  130, 0, 70,
  114, 0,  0,
    5, 0, 67,
    0, 1,  0,
    0, 2,  0,
    1, 1, 51,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 70,
    0, 1, 58,
  113, 0,  0,
    5, 0, 67,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 46,
  129, 0,  0,
    4, 0, 70,
  115, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 67,
    0, 1, 58,
  128, 0,  0,
    5, 0, 63,
  125, 1,  0,
    0, 2,  0,
    6, 0,  0,
    0, 1, 51,
  250, 0, 58,
    0, 1,  0,
    0, 2, 55,
    1, 1, 58,
  128, 0,  0,
    1, 0, 60,
  114, 0,  0,
    4, 0, 63,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  129, 0,  0,
    1, 0, 67,
  130, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 72,
    0, 1, 58,
  112, 0,  0,
    5, 0, 70,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 50,
  247, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 70,
    0, 1, 58,
  129, 0,  0,
    1, 0, 70,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 74,
    0, 1, 46,
  112, 0,  0,
    6, 0, 77,
  130, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 74,
    0, 1, 58,
  247, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 50,
  256, 1,  0,
    4, 1,  0,
    5, 1, 58,
    0, 2, 56,
  244, 0,  0,
    4, 1,  0,
    0, 2,  0,
    1, 1, 46,
  248, 1,  0,
    0, 2, 56,
    1, 1, 58,
  130, 0, 70,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 75,
    0, 1, 51,
  113, 0,  0,
    5, 0, 70,
  129, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 75,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 46,
  130, 0,  0,
    1, 0, 70,
  129, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 67,
    0, 1, 58,
  113, 0,  0,
    5, 0, 63,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 51,
  129, 0,  0,
    1, 0, 67,
  113, 0,  0,
    5, 0, 72,
    0, 1,  0,
    0, 2, 55,
    1, 1, 58,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 61,
    0, 2, 55,
  113, 0,  0,
    5, 0, 67,
  129, 0,  0,
    1, 0, 63,
  129, 0,  0,
    6, 0, 63,
  113, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 66,
    0, 1, 44,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    4, 0, 66,
    0, 1, 60,
    0, 2, 56,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 39,
  130, 0,  0,
    1, 0, 63,
  112, 0,  0,
    6, 0, 60,
    0, 1,  0,
    0, 2, 56,
    1, 1, 60,
  129, 0,  0,
    1, 0, 68,
  128, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 44,
  248, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 70,
    0, 1, 60,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 68,
    0, 1, 44,
  129, 0,  0,
    1, 0, 66,
  128, 0,  0,
    0, 1,  0,
    0, 2, 56,
    1, 0, 63,
    0, 1, 60,
  114, 0,  0,
    4, 0, 60,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 51,
  250, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 65,
    0, 1, 58,
  129, 0,  0,
    1, 0, 66,
  128, 0,  0,
    0, 1,  0,
    0, 2,  0,
    5, 0, 67,
    0, 1, 50,
  114, 0,  0,
    1, 0, 68,
  129, 0,  0,
    6, 0, 68,
    0, 1,  0,
    0, 2, 57,
    1, 1, 58,
  129, 0,  0,
    1, 0, 69,
  113, 0,  0,
    5, 0, 70,
    0, 1,  0,
    0, 2,  0,
    1, 1, 51,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 67,
    0, 1, 58,
  113, 0,  0,
    5, 0, 63,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 50,
  129, 0,  0,
    1, 0, 70,
  113, 0,  0,
    5, 0, 66,
    0, 1,  0,
    0, 2, 56,
    1, 1, 58,
  128, 0,  0,
    1, 0, 67,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 51,
  250, 0,  0,
    0, 1,  0,
    1, 0, 58,
    0, 1, 44,
  129, 0,  0,
    1, 0, 58,
  113, 0,  0,
    5, 0, 63,
    0, 1,  0,
    1, 1, 46,
  128, 0,  0,
    1, 0, 70,
  129, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 72,
    0, 1, 58,
  113, 0,  0,
    5, 0, 70,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 58,
    0, 2, 55,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
  256, 0, 70,
  256, 0, 70,
  252, 0, 70,
    0, 1, 46,
  256, 0,  0,
    5, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 41,
  128, 0,  0,
    1, 0, 65,
  113, 0,  0,
    5, 0, 62,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  129, 0,  0,
    1, 0, 62,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 46,
  113, 0,  0,
    5, 0, 65,
  129, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 67,
    0, 1, 53,
  129, 0,  0,
    1, 0, 65,
  113, 0,  0,
    5, 0, 65,
    0, 1,  0,
    0, 2,  0,
    1, 1, 41,
  129, 0,  0,
    1, 0, 62,
  130, 0,  0,
    0, 1,  0,
    5, 0, 60,
    0, 1, 53,
    0, 2, 50,
  114, 0,  0,
    1, 0, 58,
  128, 0,  0,
    5, 0, 58,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  248, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 58,
    0, 1, 53,
  130, 0,  0,
    1, 0, 62,
  128, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 62,
    0, 1, 41,
  114, 0,  0,
    5, 0, 65,
  129, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 67,
    0, 1, 53,
  130, 0,  0,
    1, 0, 65,
  112, 0,  0,
    5, 0, 70,
    0, 1,  0,
    0, 2,  0,
    1, 1, 46,
  256, 0,  0,
    3, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  248, 1,  0,
    0, 2,  0,
    1, 1, 41,
  130, 0, 65,
  113, 0,  0,
    5, 0, 67,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  130, 0,  0,
    1, 0, 68,
  128, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  248, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 41,
  129, 0,  0,
    4, 0, 65,
  125, 1,  0,
    5, 0,  0,
    0, 1, 53,
    0, 2, 50,
    1, 0, 62,
  113, 0,  0,
    5, 0, 62,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 46,
  130, 0,  0,
    1, 0, 65,
  113, 0,  0,
    5, 0, 67,
    0, 1,  0,
    0, 2, 50,
    1, 1, 53,
  128, 0,  0,
    1, 0, 65,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 65,
    0, 1, 41,
  113, 0,  0,
    5, 0, 62,
  131, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 60,
    0, 1, 53,
  129, 0,  0,
    1, 0, 58,
  113, 0,  0,
    5, 0, 65,
    0, 1,  0,
    0, 2,  0,
    1, 1, 44,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2, 48,
    1, 0, 65,
    0, 1, 53,
  113, 0,  0,
    5, 0, 65,
  131, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 68,
    0, 1, 41,
  129, 0,  0,
    1, 0, 72,
  113, 0,  0,
    5, 0, 68,
    0, 1,  0,
    0, 2, 48,
    1, 1, 53,
  128, 0,  0,
    1, 0, 67,
  129, 0,  0,
    0, 1,  0,
    0, 2,  0,
    6, 0, 65,
    0, 1, 44,
  250, 0,  0,
    0, 1,  0,
    0, 2, 48,
    1, 1, 53,
  247, 1,  0,
    0, 2,  0,
    1, 1, 41,
  129, 0, 65,
  131, 0,  0,
    0, 1,  0,
    0, 2, 48,
    1, 0, 67,
    0, 1, 53,
  112, 0,  0,
    6, 0, 68,
  130, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  247, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 41,
  248, 0,  0,
    0, 1,  0,
    0, 2, 50,
    1, 0, 70,
    0, 1, 53,
  247, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 46,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    1, 0, 70,
    0, 1, 50,
  248, 0,  0,
    0, 1,  0,
    1, 0, 67,
    0, 1, 53,
  128, 0,  0,
    5, 0, 65,
  114, 0,  0,
    0, 1,  0,
    1, 0, 62,
    0, 1, 56,
  129, 0,  0,
    6, 0, 58,
  125, 1,  0,
    5, 0,  0,
    0, 1, 51,
    1, 0, 63,
  247, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 63,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 63,
    0, 1, 46,
  256, 0,  0,
    4, 0,  0,
    0, 1,  0,
    0, 2, 55,
    1, 0, 63,
    0, 1, 58,
  247, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 67,
    0, 1, 51,
  248, 0,  0,
    0, 1,  0,
    1, 0, 70,
    0, 1, 55,
  130, 0,  0,
    1, 0, 72,
  129, 0,  0,
    0, 1,  0,
    1, 0, 73,
    0, 1, 58,
  113, 0,  0,
    5, 0, 70,
  129, 1,  0,
    1, 1, 61,
  248, 0,  0,
    0, 1,  0,
    1, 0, 74,
    0, 1, 46,
  130, 0,  0,
    1, 0, 73,
  129, 0,  0,
    0, 1,  0,
    4, 0, 74,
    0, 1, 58,
    0, 2, 53,
  115, 0,  0,
    1, 0, 73,
  128, 0,  0,
    5, 0, 74,
    0, 1,  0,
    0, 2,  0,
    1, 1, 41,
  130, 0,  0,
    1, 0, 77,
  118, 1,  0,
    0, 2, 53,
    1, 1, 58,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 74,
    0, 1, 46,
  114, 0,  0,
    4, 0, 77,
  130, 0,  0,
    0, 1,  0,
    0, 2, 53,
    1, 0, 74,
    0, 1, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 41,
  256, 0,  0,
    2, 0,  0,
    0, 1,  0,
    0, 2, 53,
    1, 0, 65,
    0, 1, 58,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 79,
    0, 1, 46,
  130, 0,  0,
    1, 0, 74,
  118, 1,  0,
    0, 2, 53,
    1, 1, 58,
  129, 0,  0,
    1, 0, 70,
  128, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 72,
    0, 1, 56,
    0, 2, 53,
  248, 0,  0,
    0, 1,  0,
    0, 2,  0,
    1, 0, 70,
    0, 1, 62,
    0, 2, 58,
  250, 0,  0,
    0, 1,  0,
    0, 2,  0,
  256, 0, 65,
    8, 0, 65,
    0, 1, 43,
  251, 0,  0,
    0, 1,  0,
    1, 0, 70,
    0, 1, 34,
  248, 0,  0,
    0, 1,  0,
};
unsigned long MidiData_length = 5895;
const unsigned int Key2Freq[128] = {
    0,    9,    9,   10,   10,   11,   12,   12,
   13,   14,   15,   15,   16,   17,   18,   19,
   21,   22,   23,   24,   26,   28,   29,   31,
   33,   35,   37,   39,   41,   44,   46,   49,
   52,   55,   58,   62,   65,   69,   73,   78,
   82,   87,   92,   98,  104,  110,  117,  123,
  131,  139,  147,  156,  165,  175,  185,  196,
  208,  220,  233,  247,  262,  277,  294,  311,
  330,  349,  370,  392,  415,  440,  466,  494,
  523,  554,  587,  622,  659,  698,  740,  784,
  831,  880,  932,  988, 1047, 1109, 1175, 1245,
 1319, 1397, 1480, 1568, 1661, 1760, 1865, 1976,
 2093, 2217, 2349, 2489, 2637, 2794, 2960, 3136,
 3322, 3520, 3729, 3951, 4186, 4435, 4699, 4978,
 5274, 5588, 5920, 6272, 6645, 7040, 7459, 7902,
 8372, 8870, 9397, 9956,10548,11175,11840,12544
};

// Define various ADC prescaler
const byte PS_16=(1<<ADPS2);
const byte PS_32=(1<<ADPS2)|(1<<ADPS0);
const byte PS_64=(1<<ADPS2)|(1<<ADPS1);
const byte PS_128=(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);

/* ISR: Tone on A0-5 */
volatile unsigned int magic=2095; // 1 ms
volatile unsigned int magic0=0;
volatile unsigned int magic1=0;
volatile unsigned int magic2=0;
volatile unsigned int magic3=0;
volatile unsigned int magic4=0;
volatile unsigned int magic5=0;
volatile unsigned int phase=0;
volatile unsigned int phase0=0;
volatile unsigned int phase1=0;
volatile unsigned int phase2=0;
volatile unsigned int phase3=0;
volatile unsigned int phase4=0;
volatile unsigned int phase5=0;
volatile unsigned long master=0;
ISR(TIMER2_OVF_vect)
{
  if (phase<0x8000) {
    phase+=magic;
    if (phase>=0x8000) master++;
  } else {
    phase+=magic;
  }
  phase0+=magic0;
  phase1+=magic1;
  phase2+=magic2;
  phase3+=magic3;
  phase4+=magic4;
  phase5+=magic5;
  if (phase0<0x8000) PORTC&=B11111110; else PORTC|=B00000001;
  if (phase1<0x8000) PORTC&=B11111101; else PORTC|=B00000010;
  if (phase2<0x8000) PORTC&=B11111011; else PORTC|=B00000100;
  if (phase3<0x8000) PORTC&=B11110111; else PORTC|=B00001000;
  if (phase4<0x8000) PORTC&=B11101111; else PORTC|=B00010000;
  if (phase5<0x8000) PORTC&=B11011111; else PORTC|=B00100000;
}

void SetKey(unsigned int Channel,unsigned int Key)
{
  Key&=0x007F;
  if (Channel==0) magic0=Key2Freq[Key];
  if (Channel==1) magic1=Key2Freq[Key];
  if (Channel==2) magic2=Key2Freq[Key];
  if (Channel==3) magic3=Key2Freq[Key];
  if (Channel==4) magic4=Key2Freq[Key];
  if (Channel==5) magic5=Key2Freq[Key];
  // Turn it off
  if (Key==0) {
    if (Channel==0) phase0=0;
    if (Channel==1) phase1=0;
    if (Channel==2) phase2=0;
    if (Channel==3) phase3=0;
    if (Channel==4) phase4=0;
    if (Channel==5) phase5=0;
  }
}

void setup()
{
  byte Delay;
  byte Channel;
  byte Key;
  pinMode(LED_BUILTIN,OUTPUT);
  pinMode(A0,OUTPUT);
  pinMode(A1,OUTPUT);
  pinMode(A2,OUTPUT);
  pinMode(A3,OUTPUT);
  pinMode(A4,OUTPUT);
  pinMode(A5,OUTPUT);
  pinMode(11,OUTPUT); // Used as a frequency check

  // Set ADC prescaler (assume a 16 MHz clock)
  ADCSRA&=~PS_128;                                 // Remove bits set by Arduino library
  ADCSRA|=PS_16;                                   // 16 prescaler (1 MHz)

  // Disable interrupts
  cli();

  // Use Timer 2 for ISR (Output on D11 for frequency check)
  // Good for ATmega48A/PA/88A/PA/168A/PA/328/P
  TIMSK2 = 0;                                      // Timer interrupts off
  TCCR2A = (2 << COM2A0)|(1 << WGM20);             // Phase correct PWM (31275.5 Hz), toggle output on OC2A (PB3/D11)
  TCCR2B = (0 << WGM22)|(1 << CS20);               // 16 MHz clock (no pre-scaler)
  OCR2A = 128;                                     // Set 50% duty
  TIMSK2 = (1<<TOIE2);                             // Set interrupt on overflow (=BOTTOM)

  // Enable interrupts
  sei();

  // Play "YaketyAxe.mid":
  // Channels found:
  //    0
  //    1
  //    2
  for (unsigned int i=0;i<MidiData_length;i+=3) {
    Delay=pgm_read_byte(MidiData+i);
    Channel=pgm_read_byte(MidiData+i+1);
    Key=pgm_read_byte(MidiData+i+2);
    // Remap high channels
    delay(Delay); SetKey(Channel,Key);
  }
  // Shutdown
  SetKey(0, 0);
  SetKey(1, 0);
  SetKey(2, 0);
  SetKey(3, 0);
  SetKey(4, 0);
  SetKey(5, 0);
}

void loop()
{
  delay(1000);
  digitalWrite(LED_BUILTIN,!digitalRead(LED_BUILTIN));
}
